type Primitive = string | number | boolean | null | undefined;
export type StaticProperties = Map<string, Primitive>;
/**
 * @todo: this was implemented before all other schemas and is used only for composition.
 * it needs to be align with other schemas.
 */
export declare class Export {
    /**
     * named export identifier of the module export.
     */
    readonly identifier: string;
    /**
     * static properties attached to this export
     * @example
     * export hello = () => {};
     * hello.value = "text"; // <-- staticProperty
     * hello.count = 3; // <-- static property
     */
    readonly staticProperties?: StaticProperties | undefined;
    constructor(
    /**
     * named export identifier of the module export.
     */
    identifier: string, 
    /**
     * static properties attached to this export
     * @example
     * export hello = () => {};
     * hello.value = "text"; // <-- staticProperty
     * hello.count = 3; // <-- static property
     */
    staticProperties?: StaticProperties | undefined);
    toObject(): {
        constructorName: string;
        identifier: string;
    };
}
export {};
