import { SchemaLocation, SchemaNode } from '../schema-node';
import { DocSchema } from './docs';
import { ExpressionWithTypeArgumentsSchema } from './expression-with-arguments';
export declare class ClassSchema extends SchemaNode {
    readonly name: string;
    readonly location: SchemaLocation;
    readonly signature: string;
    readonly typeParams?: string[] | undefined;
    readonly extendsNodes?: ExpressionWithTypeArgumentsSchema[] | undefined;
    readonly implementNodes?: ExpressionWithTypeArgumentsSchema[] | undefined;
    readonly decorators?: SchemaNode[] | undefined;
    readonly members: SchemaNode[];
    readonly doc?: DocSchema;
    constructor(name: string, members: SchemaNode[], location: SchemaLocation, signature: string, doc?: DocSchema, typeParams?: string[] | undefined, extendsNodes?: ExpressionWithTypeArgumentsSchema[] | undefined, implementNodes?: ExpressionWithTypeArgumentsSchema[] | undefined, decorators?: SchemaNode[] | undefined);
    getNodes(): SchemaNode[];
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        members: Record<string, any>[];
        doc: {
            __schema: string;
            name: string | undefined;
            location: SchemaLocation;
            signature: string | undefined;
            raw: string;
            comment: string | undefined;
            tags: {
                __schema: string;
                location: SchemaLocation;
                name: string | undefined;
                signature: string | undefined;
                tagName: string;
                comment: string | undefined;
            }[] | undefined;
        } | undefined;
        signature: string;
        typeParams: string[] | undefined;
        extendsNodes: {
            name: string;
            location: SchemaLocation;
            typeArgs: Record<string, any>[];
            expression: SchemaNode;
        }[] | undefined;
        implementNodes: {
            name: string;
            location: SchemaLocation;
            typeArgs: Record<string, any>[];
            expression: SchemaNode;
        }[] | undefined;
        decorators: Record<string, any>[] | undefined;
    };
    static fromObject(obj: Record<string, any>): ClassSchema;
    static fromSchema(node: ClassSchema, memberTransformer?: (_node: SchemaNode) => SchemaNode): ClassSchema;
}
