"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConstructorSchema = void 0;
function _parameter() {
  const data = require("./parameter");
  _parameter = function () {
    return data;
  };
  return data;
}
function _functionLike() {
  const data = require("./function-like");
  _functionLike = function () {
    return data;
  };
  return data;
}
function _docs() {
  const data = require("./docs");
  _docs = function () {
    return data;
  };
  return data;
}
function _thisType() {
  const data = require("./this-type");
  _thisType = function () {
    return data;
  };
  return data;
}
class ConstructorSchema extends _functionLike().FunctionLikeSchema {
  constructor(location, params, returnType, signature, modifiers = [], doc) {
    super(location, 'constructor', params, returnType, signature, modifiers, doc, undefined);
  }
  static fromObject(obj) {
    const location = obj.location;
    const params = obj.params.map(param => _parameter().ParameterSchema.fromObject(param));
    const returns = _thisType().ThisTypeSchema.fromObject(obj.returnType);
    const signature = obj.signature;
    const modifiers = obj.modifiers;
    const doc = obj.doc ? _docs().DocSchema.fromObject(obj.doc) : undefined;
    return new ConstructorSchema(location, params, returns, signature, modifiers, doc);
  }
}
exports.ConstructorSchema = ConstructorSchema;

//# sourceMappingURL=constructor.js.map