import { SchemaLocation, SchemaNode } from '../schema-node';
import { DocSchema } from './docs';
export declare class DecoratorSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly doc?: DocSchema | undefined;
    readonly args?: SchemaNode[] | undefined;
    constructor(location: SchemaLocation, name: string, doc?: DocSchema | undefined, args?: SchemaNode[] | undefined);
    getNodes(): SchemaNode[];
    toString(): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        doc: {
            __schema: string;
            name: string | undefined;
            location: SchemaLocation;
            signature: string | undefined;
            raw: string;
            comment: string | undefined;
            tags: {
                __schema: string;
                location: SchemaLocation;
                name: string | undefined;
                signature: string | undefined;
                tagName: string;
                comment: string | undefined;
            }[] | undefined;
        } | undefined;
        args: Record<string, any>[] | undefined;
    };
    static fromObject(obj: Record<string, any>): DecoratorSchema;
}
