import { SchemaLocation, SchemaNode } from '../../schema-node';
import { TagSchema } from './tag';
/**
 * e.g. `@param myParam {string} some comment`
 */
export declare class PropertyLikeTagSchema extends TagSchema {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly comment?: string | undefined;
    readonly type?: SchemaNode;
    constructor(location: SchemaLocation, name: string, comment?: string | undefined, type?: SchemaNode);
    toString(): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        type: Record<string, any> | undefined;
        __schema: string;
        location: SchemaLocation;
        signature: string | undefined;
        tagName: string;
        comment: string | undefined;
    };
    static fromObject(obj: Record<string, any>): PropertyLikeTagSchema;
}
