import { SchemaLocation, SchemaNode } from '../../schema-node';
/**
 * e.g. `@deprecated please use something else`
 */
export declare class TagSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly tagName: TagName | string;
    readonly comment?: string | undefined;
    constructor(location: SchemaLocation, tagName: TagName | string, comment?: string | undefined);
    toString(): string;
    toFullSignature(): string;
    static fromObject(obj: Record<string, any>): TagSchema;
    toObject(): {
        __schema: string;
        location: SchemaLocation;
        name: string | undefined;
        signature: string | undefined;
        tagName: string;
        comment: string | undefined;
    };
}
export declare enum TagName {
    augments = "augments",
    author = "author",
    class = "class",
    callback = "callback",
    public = "public",
    private = "private",
    protected = "protected",
    readonly = "readonly",
    override = "override",
    see = "see",
    enum = "enum",
    parameter = "parameter",
    this = "this",
    type = "type",
    template = "template",
    typedef = "typedef",
    property = "property",
    implements = "implements",
    return = "return",
    deprecated = "deprecated",
    exports = "exports",
    link = "link"
}
