"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TagSchema = exports.TagName = void 0;
function _schemaNode() {
  const data = require("../../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
/**
 * e.g. `@deprecated please use something else`
 */
class TagSchema extends _schemaNode().SchemaNode {
  constructor(location, tagName, comment) {
    super();
    this.location = location;
    this.tagName = tagName;
    this.comment = comment;
  }
  toString() {
    const comment = this.comment ? ` ${this.comment}` : '';
    return `@${this.tagName}${comment}`;
  }
  toFullSignature() {
    return this.toString();
  }
  static fromObject(obj) {
    const location = obj.location;
    const tagName = obj.tagName;
    const comment = obj.comment;
    return new TagSchema(location, tagName, comment);
  }
  toObject() {
    return {
      __schema: this.__schema,
      location: this.location,
      name: this.name,
      signature: this.signature,
      tagName: this.tagName,
      comment: this.comment
    };
  }
}
exports.TagSchema = TagSchema;
let TagName = exports.TagName = /*#__PURE__*/function (TagName) {
  TagName["augments"] = "augments";
  TagName["author"] = "author";
  TagName["class"] = "class";
  TagName["callback"] = "callback";
  TagName["public"] = "public";
  TagName["private"] = "private";
  TagName["protected"] = "protected";
  TagName["readonly"] = "readonly";
  TagName["override"] = "override";
  TagName["see"] = "see";
  TagName["enum"] = "enum";
  TagName["parameter"] = "parameter";
  TagName["this"] = "this";
  TagName["type"] = "type";
  TagName["template"] = "template";
  TagName["typedef"] = "typedef";
  TagName["property"] = "property";
  TagName["implements"] = "implements";
  TagName["return"] = "return";
  TagName["deprecated"] = "deprecated";
  TagName["exports"] = "exports";
  TagName["link"] = "link";
  return TagName;
}({});

//# sourceMappingURL=tag.js.map