import { SchemaLocation, SchemaNode } from '../schema-node';
import { DocSchema } from './docs';
export declare class EnumMemberSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly signature: string;
    readonly value?: string | undefined;
    readonly doc?: DocSchema;
    constructor(location: SchemaLocation, name: string, signature: string, value?: string | undefined, doc?: DocSchema);
    toString(): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        signature: string;
        value: string | undefined;
        doc: {
            __schema: string;
            name: string | undefined;
            location: SchemaLocation;
            signature: string | undefined;
            raw: string;
            comment: string | undefined;
            tags: {
                __schema: string;
                location: SchemaLocation;
                name: string | undefined;
                signature: string | undefined;
                tagName: string;
                comment: string | undefined;
            }[] | undefined;
        } | undefined;
    };
    static fromObject(obj: Record<string, any>): EnumMemberSchema;
}
