import { SchemaLocation, SchemaNode } from '../schema-node';
import { DocSchema } from './docs';
export declare class EnumSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly signature: string;
    readonly doc?: DocSchema;
    readonly members: SchemaNode[];
    constructor(location: SchemaLocation, name: string, members: SchemaNode[], signature: string, doc?: DocSchema);
    getNodes(): SchemaNode[];
    toString(options: any): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        members: Record<string, any>[];
        doc: {
            __schema: string;
            name: string | undefined;
            location: SchemaLocation;
            signature: string | undefined;
            raw: string;
            comment: string | undefined;
            tags: {
                __schema: string;
                location: SchemaLocation;
                name: string | undefined;
                signature: string | undefined;
                tagName: string;
                comment: string | undefined;
            }[] | undefined;
        } | undefined;
        signature: string;
    };
    static fromObject(obj: Record<string, any>): EnumSchema;
}
