import { SchemaNode, SchemaLocation } from '../schema-node';
import { DocSchema } from './docs';
export declare class ExportSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    alias?: string;
    exportNode: SchemaNode;
    readonly doc?: DocSchema;
    readonly signature?: string;
    constructor(location: SchemaLocation, name: string, exportNode: SchemaNode, alias?: string, doc?: DocSchema);
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        doc: {
            __schema: string;
            name: string | undefined;
            location: SchemaLocation;
            signature: string | undefined;
            raw: string;
            comment: string | undefined;
            tags: {
                __schema: string;
                location: SchemaLocation;
                name: string | undefined;
                signature: string | undefined;
                tagName: string;
                comment: string | undefined;
            }[] | undefined;
        } | undefined;
        location: SchemaLocation;
        exportNode: Record<string, any>;
        alias: string | undefined;
    };
    static fromObject(obj: Record<string, any>): ExportSchema;
    static isExportSchema(node: SchemaNode): node is ExportSchema;
}
