"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExpressionWithTypeArgumentsSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
class ExpressionWithTypeArgumentsSchema extends _schemaNode().SchemaNode {
  constructor(typeArgs, expression, name, location) {
    super();
    this.name = name;
    this.location = location;
    this.typeArgs = typeArgs;
    this.expression = expression;
  }
  toString() {
    return this.name;
  }
  toFullSignature(options) {
    let result = this.name;
    if (this.typeArgs && this.typeArgs.length > 0) {
      const typeArgsStr = this.typeArgs.map(arg => arg.toFullSignature(options)).join(', ');
      result += `<${typeArgsStr}>`;
    }
    return result;
  }
  toObject() {
    return {
      ...super.toObject(),
      name: this.name,
      location: this.location,
      typeArgs: this.typeArgs.map(typeArg => typeArg.toObject()),
      expression: this.expression
    };
  }
  static fromObject(obj) {
    const name = obj.name;
    const location = obj.location;
    const typeArgs = obj.typeArgs.map(typeArg => _schemaRegistry().SchemaRegistry.fromObject(typeArg));
    const expression = _schemaRegistry().SchemaRegistry.fromObject(obj.expression);
    return new ExpressionWithTypeArgumentsSchema(typeArgs, expression, name, location);
  }
}
exports.ExpressionWithTypeArgumentsSchema = ExpressionWithTypeArgumentsSchema;

//# sourceMappingURL=expression-with-arguments.js.map