"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GetAccessorSchema = void 0;
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function () {
    return data;
  };
  return data;
}
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class GetAccessorSchema extends _schemaNode().SchemaNode {
  constructor(location, name, type, signature) {
    super();
    this.location = location;
    this.name = name;
    this.signature = signature;
    this.type = type;
  }
  getSignature() {
    return this.signature;
  }
  getNodes() {
    return [this.type];
  }
  toString(options) {
    const bold = options?.color ? _chalk().default.bold : x => x;
    return `get ${bold(this.name)}(): ${this.type.toString(options)}`;
  }
  toFullSignature(options) {
    let result = '';
    if (options?.showDocs && this.doc) {
      result += `${this.doc.toFullSignature()}\n`;
    }
    result += `get ${this.name}(): ${this.type.toFullSignature(options)}`;
    return result;
  }
  toObject() {
    return {
      ...super.toObject(),
      name: this.name,
      type: this.type.toObject(),
      signature: this.signature
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const name = obj.name;
    const type = _schemaRegistry().SchemaRegistry.fromObject(obj.type);
    const signature = obj.signature;
    return new GetAccessorSchema(location, name, type, signature);
  }
}
exports.GetAccessorSchema = GetAccessorSchema;

//# sourceMappingURL=get-accessor.js.map