import { SchemaLocation, SchemaNode } from '../schema-node';
import { ParameterSchema } from './parameter';
/**
 * [key: number]: string
 * keyType: number
 * valueType: string
 */
export declare class IndexSignatureSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly keyType: SchemaNode;
    readonly valueType: SchemaNode;
    constructor(location: SchemaLocation, keyType: ParameterSchema, valueType: SchemaNode);
    toString(): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        location: SchemaLocation;
        keyType: Record<string, any>;
        valueType: Record<string, any>;
    };
    static fromObject(obj: Record<string, any>): IndexSignatureSchema;
}
