"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IndexSignatureSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
function _parameter() {
  const data = require("./parameter");
  _parameter = function () {
    return data;
  };
  return data;
}
/**
 * [key: number]: string
 * keyType: number
 * valueType: string
 */
class IndexSignatureSchema extends _schemaNode().SchemaNode {
  constructor(location, keyType, valueType) {
    super();
    this.location = location;
    this.keyType = keyType;
    this.valueType = valueType;
  }
  toString() {
    return `[${this.keyType.toString()}]: ${this.valueType.toString()}`;
  }
  toFullSignature(options) {
    const keyTypeStr = this.keyType.toFullSignature(options);
    const valueTypeStr = this.valueType.toFullSignature(options);
    return `[${keyTypeStr}]: ${valueTypeStr}`;
  }
  toObject() {
    return {
      ...super.toObject(),
      location: this.location,
      keyType: this.keyType.toObject(),
      valueType: this.valueType.toObject()
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const keyType = _parameter().ParameterSchema.fromObject(obj.keyType);
    const valueType = _schemaRegistry().SchemaRegistry.fromObject(obj.valueType);
    return new IndexSignatureSchema(location, keyType, valueType);
  }
}
exports.IndexSignatureSchema = IndexSignatureSchema;

//# sourceMappingURL=index-signature.js.map