"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IndexedAccessSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
class IndexedAccessSchema extends _schemaNode().SchemaNode {
  constructor(location, objectType, indexType) {
    super();
    this.location = location;
    this.objectType = objectType;
    this.indexType = indexType;
  }
  getNodes() {
    return [this.objectType, this.indexType];
  }
  toString() {
    return `${this.objectType.toString()}[${this.indexType.toString()}]`;
  }
  toFullSignature(options) {
    const objectTypeStr = this.objectType.toFullSignature(options);
    const indexTypeStr = this.indexType.toFullSignature(options);
    return `${objectTypeStr}[${indexTypeStr}]`;
  }
  toObject() {
    return {
      ...super.toObject(),
      objectType: this.objectType.toObject(),
      indexType: this.indexType.toObject()
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const objectType = _schemaRegistry().SchemaRegistry.fromObject(obj.objectType);
    const indexType = _schemaRegistry().SchemaRegistry.fromObject(obj.indexType);
    return new IndexedAccessSchema(location, objectType, indexType);
  }
}
exports.IndexedAccessSchema = IndexedAccessSchema;

//# sourceMappingURL=indexed-access-type.js.map