"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InferenceTypeSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
/**
 * where there is no explicit type, the type is taken from the "quickinfo" of tsserver
 */
class InferenceTypeSchema extends _schemaNode().SchemaNode {
  constructor(location, type, name, defaultValue, isSpread, alias) {
    super();
    this.location = location;
    this.type = type;
    this.name = name;
    this.defaultValue = defaultValue;
    this.isSpread = isSpread;
    this.alias = alias;
  }
  toString() {
    if (this.name && this.name !== this.type) {
      return `${this.name}: ${this.type}`;
    }
    return this.type;
  }
  toFullSignature() {
    let result = '';
    if (this.name && this.name !== this.type) {
      result += `${this.name}: `;
    }
    result += this.type;
    if (this.defaultValue !== undefined) {
      result += ` = ${this.defaultValue}`;
    }
    return result;
  }
  toObject() {
    return {
      ...super.toObject(),
      type: this.type,
      defaultValue: this.defaultValue,
      isSpread: this.isSpread,
      alias: this.alias
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const type = obj.type;
    const name = obj.name;
    const defaultValue = obj.defaultValue;
    const isSpread = obj.isSpread;
    const alias = obj.alias;
    return new InferenceTypeSchema(location, type, name, defaultValue, isSpread, alias);
  }
}
exports.InferenceTypeSchema = InferenceTypeSchema;

//# sourceMappingURL=inference-type.js.map