import { SchemaLocation, SchemaNode } from '../schema-node';
export declare class ModuleSchema extends SchemaNode {
    readonly location: SchemaLocation;
    exports: SchemaNode[];
    internals: SchemaNode[];
    namespace?: string;
    constructor(location: SchemaLocation, exports: SchemaNode[], internals: SchemaNode[]);
    getNodes(): SchemaNode[];
    flatExportsRecursively(): void;
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        exports: Record<string, any>[];
        internals: Record<string, any>[];
        namespace: string | undefined;
    };
    static fromObject(obj: Record<string, any>): ModuleSchema;
}
