"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PropertyAssignmentSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
function _docs() {
  const data = require("./docs");
  _docs = function () {
    return data;
  };
  return data;
}
class PropertyAssignmentSchema extends _schemaNode().SchemaNode {
  constructor(name, value, location, doc) {
    super();
    this.name = name;
    this.value = value;
    this.location = location;
    this.doc = doc;
  }
  toString(options) {
    return `${this.name}: ${this.value.toString(options)}`;
  }
  toFullSignature(options) {
    let result = '';
    if (options?.showDocs && this.doc) {
      result += `${this.doc.toFullSignature()}\n`;
    }
    const valueStr = this.value.toFullSignature(options);
    result += `${this.name}: ${valueStr}`;
    return result;
  }
  toObject() {
    return {
      ...super.toObject(),
      name: this.name,
      value: this.value.toObject(),
      doc: this.doc?.toObject(),
      location: this.location
    };
  }
  static fromObject(obj) {
    const name = obj.name;
    const value = _schemaRegistry().SchemaRegistry.fromObject(obj.value);
    const location = obj.location;
    const doc = obj.doc ? _docs().DocSchema.fromObject(obj.doc) : undefined;
    return new PropertyAssignmentSchema(name, value, location, doc);
  }
}
exports.PropertyAssignmentSchema = PropertyAssignmentSchema;

//# sourceMappingURL=property-assignment.js.map