"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SetAccessorSchema = void 0;
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function () {
    return data;
  };
  return data;
}
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _parameter() {
  const data = require("./parameter");
  _parameter = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class SetAccessorSchema extends _schemaNode().SchemaNode {
  constructor(location, name, param, signature) {
    super();
    this.location = location;
    this.name = name;
    this.signature = signature;
    this.param = param;
  }
  getSignature() {
    return this.signature;
  }
  toString() {
    return `set ${_chalk().default.bold(this.name)}(${this.param.toString()})`;
  }
  toFullSignature(options) {
    const paramStr = this.param.toFullSignature(options);
    return `set ${this.name}(${paramStr})`;
  }
  toObject() {
    return {
      ...super.toObject(),
      name: this.name,
      param: this.param.toObject(),
      signature: this.signature
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const name = obj.name;
    const param = _parameter().ParameterSchema.fromObject(obj.param);
    const signature = obj.signature;
    return new SetAccessorSchema(location, name, param, signature);
  }
}
exports.SetAccessorSchema = SetAccessorSchema;

//# sourceMappingURL=set-accessor.js.map