import { SchemaLocation, SchemaNode } from '../schema-node';
import { TemplateLiteralTypeSpanSchema } from './template-literal-type-span';
export declare class TemplateLiteralTypeSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly head: string;
    readonly templateSpans: TemplateLiteralTypeSpanSchema[];
    constructor(location: SchemaLocation, head: string, templateSpans: TemplateLiteralTypeSpanSchema[]);
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        head: string;
        templateSpans: {
            literal: string;
            type: Record<string, any>;
        }[];
    };
    static fromObject(obj: Record<string, any>): TemplateLiteralTypeSchema;
}
