"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThisTypeSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
/**
 * e.g. `class A { createA(): this {} }`
 */
class ThisTypeSchema extends _schemaNode().SchemaNode {
  constructor(location, name) {
    super();
    this.location = location;
    this.name = name;
  }
  toString() {
    return this.name;
  }
  toFullSignature() {
    return this.toString();
  }
  static fromObject(obj) {
    const location = obj.location;
    const name = obj.name;
    return new ThisTypeSchema(location, name);
  }
}
exports.ThisTypeSchema = ThisTypeSchema;

//# sourceMappingURL=this-type.js.map