"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeArraySchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
class TypeArraySchema extends _schemaNode().SchemaNode {
  constructor(location, type) {
    super();
    this.location = location;
    this.type = type;
  }
  getNodes() {
    return [this.type];
  }
  toString(options) {
    return `${this.type.toString(options)}[]`;
  }
  toFullSignature(options) {
    return `${this.type.toFullSignature(options)}[]`;
  }
  toObject() {
    return {
      ...super.toObject(),
      type: this.type.toObject()
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const type = _schemaRegistry().SchemaRegistry.fromObject(obj.type);
    return new TypeArraySchema(location, type);
  }
}
exports.TypeArraySchema = TypeArraySchema;

//# sourceMappingURL=type-array.js.map