"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeIntersectionSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
class TypeIntersectionSchema extends _schemaNode().SchemaNode {
  constructor(location, types) {
    super();
    this.location = location;
    this.types = types;
  }
  getNodes() {
    return this.types;
  }
  toString(options) {
    return `${this.types.map(type => type.toString(options)).join(' & ')}`;
  }
  toFullSignature(options) {
    return this.types.map(type => type.toFullSignature(options)).join(' & ');
  }
  toObject() {
    return {
      ...super.toObject(),
      types: this.types.map(type => type.toObject())
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const types = obj.types.map(type => _schemaRegistry().SchemaRegistry.fromObject(type));
    return new TypeIntersectionSchema(location, types);
  }
}
exports.TypeIntersectionSchema = TypeIntersectionSchema;

//# sourceMappingURL=type-intersection.js.map