import { SchemaLocation, SchemaNode } from '../schema-node';
/**
 * e.g. `function f(str: any): str is string {}`
 *
 * example when the type is empty:
 * ```ts
 * function assert(condition: any, msg?: string): asserts condition {
 *  if (!condition) {
 *   throw new AssertionError(msg);
 *  }
 * }
 * ```
 *
 */
export declare class TypePredicateSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly hasAssertsModifier: boolean;
    readonly type?: SchemaNode;
    constructor(location: SchemaLocation, name: string, type?: SchemaNode, hasAssertsModifier?: boolean);
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        type: Record<string, any> | undefined;
        hasAssertsModifier: boolean;
    };
    static fromObject(obj: Record<string, any>): TypePredicateSchema;
}
