"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeQuerySchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
function _schemaRegistry() {
  const data = require("../schema-registry");
  _schemaRegistry = function () {
    return data;
  };
  return data;
}
/**
 * e.g. `typeof Foo`
 */
class TypeQuerySchema extends _schemaNode().SchemaNode {
  constructor(location, type, signature) {
    super();
    this.location = location;
    this.signature = signature;
    this.type = type;
  }
  getNodes() {
    return [this.type];
  }
  getSignature() {
    return this.signature;
  }
  toString(options) {
    return `typeof ${this.type.toString(options)}`;
  }
  toFullSignature(options) {
    return `typeof ${this.type.toFullSignature(options)}`;
  }
  toObject() {
    return {
      ...super.toObject(),
      type: this.type.toObject(),
      signature: this.signature
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const type = _schemaRegistry().SchemaRegistry.fromObject(obj.type);
    const signature = obj.signature;
    return new TypeQuerySchema(location, type, signature);
  }
}
exports.TypeQuerySchema = TypeQuerySchema;

//# sourceMappingURL=type-query.js.map