import { SchemaLocation, SchemaNode } from '../schema-node';
import { DocSchema } from './docs';
export declare class TypeSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly signature: string;
    readonly type: SchemaNode;
    readonly doc?: DocSchema;
    constructor(location: SchemaLocation, name: string, type: SchemaNode, signature: string, doc?: DocSchema);
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    getNodes(): SchemaNode[];
    toObject(): {
        name: string;
        type: Record<string, any>;
        signature: string;
    };
    static fromObject(obj: Record<string, any>): TypeSchema;
}
