"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnknownSchema = void 0;
function _schemaNode() {
  const data = require("../schema-node");
  _schemaNode = function () {
    return data;
  };
  return data;
}
/**
 * needed for better backward and forward compatibility.
 * in case a previous version of the semantic-schema had a schema class that doesn't exist anymore, then it'll be
 * wrapped in this class.
 */
class UnknownSchema extends _schemaNode().SchemaNode {
  constructor(location, name, schemaObj) {
    super();
    this.location = location;
    this.name = name;
    this.schemaObj = schemaObj;
  }
  toString() {
    return `<<unknown schema ${this.name}>>`;
  }
  toFullSignature() {
    return this.toString();
  }
  toObject() {
    return {
      ...super.toObject(),
      schemaObj: this.schemaObj
    };
  }
  static fromObject(obj) {
    const location = obj.location;
    const name = obj.name;
    const schemaObj = obj.schemaObj;
    return new UnknownSchema(location, name, schemaObj);
  }
}
exports.UnknownSchema = UnknownSchema;

//# sourceMappingURL=unknown-schema.js.map