import { SchemaLocation, SchemaNode } from '../schema-node';
import { DocSchema } from './docs';
/**
 * can be also a property or property-signature
 */
export declare class VariableLikeSchema extends SchemaNode {
    readonly location: SchemaLocation;
    readonly name: string;
    readonly signature: string;
    readonly isOptional: boolean;
    readonly defaultValue?: string | undefined;
    type: SchemaNode;
    readonly doc?: DocSchema;
    constructor(location: SchemaLocation, name: string, signature: string, type: SchemaNode, isOptional: boolean, doc?: DocSchema, defaultValue?: string | undefined);
    getNodes(): SchemaNode[];
    toString(options?: {
        color?: boolean;
    }): string;
    toFullSignature(options?: {
        showDocs?: boolean;
    }): string;
    toObject(): {
        name: string;
        signature: string;
        type: Record<string, any>;
        isOptional: boolean;
        doc: {
            __schema: string;
            name: string | undefined;
            location: SchemaLocation;
            signature: string | undefined;
            raw: string;
            comment: string | undefined;
            tags: {
                __schema: string;
                location: SchemaLocation;
                name: string | undefined;
                signature: string | undefined;
                tagName: string;
                comment: string | undefined;
            }[] | undefined;
        } | undefined;
        defaultValue: string | undefined;
    };
    static fromObject(obj: Record<string, any>): VariableLikeSchema;
}
